#include <stdio.h>
#include <sys/time.h>
#include <sys/resource.h>

void print_timer(FILE *Datafile, char *outputstr, struct rusage usage_start,
                 struct rusage usage_stop);

void linear_(int *NETTOP, int *LOBUS, int *LBOLD, int *NLAST, int *LLNET)
{
   FILE *Datafile;  
   int MODE = 1;
   struct rusage usage_start;
   struct rusage usage_stop;

   if ((Datafile = fopen("ETMSPSP.timing", "a+")) != NULL)
   {
      if ((*NETTOP == 1) || (*LOBUS != *LBOLD))
      {
         fprintf(Datafile, "ORDER timing\n");
         getrusage(RUSAGE_SELF, &usage_start);
         order_(NLAST, LLNET);
         getrusage(RUSAGE_SELF, &usage_stop);
         print_timer(Datafile, "order time: ", usage_start, usage_stop);
      }

      fprintf(Datafile, "Factor timing\n");
      fprintf(Datafile, "factorizing matrix (%ld,%d).\n", *NLAST, *NLAST);

      getrusage(RUSAGE_SELF, &usage_start);

      acorec_(NLAST, LLNET);

      afactc_(&MODE, NLAST);

      getrusage(RUSAGE_SELF, &usage_stop);
      print_timer(Datafile, "factor time: ", usage_start, usage_stop);

      fclose(Datafile);
   }
   else
   {
      perror("linear_()");
      exit(1);
   }
}

void print_timer(FILE *Datafile, char *outputstr, struct rusage usage_start,
                 struct rusage usage_stop)
{
   long user_sec = 0;
   long user_usec = 0;
   long sys_sec = 0;
   long sys_usec = 0;
   long sec;
   long usec;

   fprintf(Datafile, "usage_start.user_time: %ld sec %ld usec\n",
           usage_start.ru_utime.tv_sec, usage_start.ru_utime.tv_usec);
   fprintf(Datafile, "usage_stop.user_time: %ld sec %ld usec\n",
           usage_stop.ru_utime.tv_sec, usage_stop.ru_utime.tv_usec);
   fprintf(Datafile, "usage_start.sys_time: %ld sec %ld usec\n",
           usage_start.ru_stime.tv_sec, usage_start.ru_stime.tv_usec);
   fprintf(Datafile, "usage_stop.sys_time: %ld sec %ld usec\n",
           usage_stop.ru_stime.tv_sec, usage_stop.ru_stime.tv_usec);

   fprintf(Datafile, "\n");

   user_sec = usage_stop.ru_utime.tv_sec - usage_start.ru_utime.tv_sec;
   sys_sec = usage_stop.ru_stime.tv_sec - usage_start.ru_stime.tv_sec;

   sec = user_sec + sys_sec;

   if (user_sec > 0)
      user_usec = (999999 - usage_start.ru_utime.tv_usec) +
                  usage_stop.ru_utime.tv_usec;
   else
      user_usec = usage_stop.ru_utime.tv_usec - usage_start.ru_utime.tv_usec;

   if (sys_sec > 0)
      sys_usec = (999999 - usage_start.ru_stime.tv_usec) +
                  usage_stop.ru_stime.tv_usec;
   else
      sys_usec = usage_stop.ru_stime.tv_usec - usage_start.ru_stime.tv_usec;

   usec = user_usec + sys_usec;

   if (usec >= 1000000)
   {
      sec += usec / 1000000;
      usec = usec % 1000000;
   }

   if (sec > 0)
      fprintf(Datafile, "%s %ld sec and %ld usec\n", outputstr, sec, usec);
   else
      fprintf(Datafile, "%s %ld usec\n", outputstr, usec);

   fprintf(Datafile, "\n");
}
